#include<stdio.h>
#include<stdlib.h>

#define MAX 100
typedef char DataType;

typedef struct tnode{
	DataType data;
	struct tnode *rc;//Һ 
	struct tnode *lc;// 
}BT;

// 
void DLR(BT *T)
{
	if(T != NULL)
	{
		printf("%c",T->data);
		DLR(T->lc);// 
		DLR(T->rc);
	}
}

// 
void LDR(BT *T)
{
	if(T != NULL)
	{
		LDR(T->lc);
		printf("%c",T->data);
		LDR(T->rc);
	}
}

// 
void LRD(BT *T)
{
	if(T != NULL)
	{
		LRD(T->lc);
		LRD(T->rc);
		printf("%c",T->data);
	}
}

//α 
void LevelOrder(BT *T)
{
	int f,r;		//ͷβָ 
	BT *p,*q[MAX];	//ѭУŽڵָ 
	p=T;
	if(p!=NULL)		//ǿգڵַ 
	{
		f = 1;
		q[f] = p;
		r = 2;
	}
	while(f!=r)
	{
		p=q[f];
		printf("%c",p->data);
		if(p->lc != NULL)//׽ڵ 
		{
			q[r] = p->lc;
			r = (r+1)%MAX;
		}
		if(p->rc != NULL)//׽ڵк 
		{
			q[r] = p->rc;
			r = (r+1)%MAX;
		}
		f = (f+1)%MAX;
	}
}


//
BT *CreateBTree()
{
	BT* t;
	char ch;
	printf("ڵ\n"); 
	scanf("%c",&ch);
	getchar();
	if(ch == '0')
	{
		t = NULL;
	}
	else
	{
		t = (BT*)malloc(sizeof(BT));
		t->data = ch;
		printf("%cڵӽڵ(0ȡ)\n",t->data);
		t->lc = CreateBTree();
		printf("%cڵҺӽڵ(0ȡ)\n",t->data);
		t->rc = CreateBTree();
	}
	return t;
} 

//չʾ 
void ShowBTree(BT *T)
{
	if(T != NULL)
	{
		printf("%c",T->data);
		if(T->lc != NULL)
		{
			printf("(");
			ShowBTree(T->lc);
			if(T->rc != NULL)
			{
				printf(",");
				ShowBTree(T->rc);
			}
			printf(")");
		}
		else if(T->rc != NULL)
		{
			printf("(");
			ShowBTree(T->lc);
			if(T->rc != NULL)
			{
				printf(",");
				ShowBTree(T->rc);
			}
			printf(")");
		}
	}
}

//Ҷӽڵ 
int leaf_num(BT *T)
{
    if (T == NULL)
        return 0;
    if (T->lc == NULL && T->rc == NULL)
        return 1;

    return (leaf_num(T->lc) + leaf_num(T->rc));
}

//ܽ 
int node_num(BT *T)
{
	int tmp1 = 0, tmp2 = 0;
	if(T == NULL)
		return 0;
	tmp1 = node_num(T->lc);
	tmp2 = node_num(T->rc);
	return 1+tmp1+tmp2;
}

// 
int TreeDepth(BT *T)
{
	int ldepth = 0;// 
	int rdepth = 0;// 
	if(T == NULL)
	{
		return 0;
	}
	else
	{
		ldepth = TreeDepth(T->lc);
		rdepth = TreeDepth(T->rc);
		if(ldepth > rdepth)
			return ldepth+1;
		else
			return rdepth+1;
	}
}

//˵ 
void menu()
{
	char word[][30]={{"1.\n"},{"2.\n"},{"3.\n"},{"4.\n"},{"5.\n"},{"6.α\n"},
					{"7.Ҷӽڵ\n"},{"8.ܽڵ\n"},{"9.\n"},{"0.˳\n"}};
	for(int i = 0;i<10;i++)
	{
		printf("%s",word[i]);
	}
}


int main()
{
	//menu();
	BT* tree = NULL;
	char ch = '0';
	while(1)
	{
		system("cls");
		menu();
		scanf("%c",&ch);
		getchar();
		
		switch(ch)
		{
			case '1':
				tree = CreateBTree();
				printf("ɹ\n");
				break;
			case '2':
				ShowBTree(tree);
				printf("\n");
				break;
			case '3':
				DLR(tree);
				break;
			case '4':
				LDR(tree);
				break;
			case '5':
				LRD(tree);
				break;
			case '6':
				LevelOrder(tree);
				break;
			case '7':
				printf("\n");
				printf("Ҷӽڵ%d\n",leaf_num(tree));
				break;
			case '8':
				printf("ܽڵΪ%d\n",node_num(tree));
				break;
			case '9':
				printf("Ϊ%d\n",TreeDepth(tree));
				break;
			case '0':
				return 0;
				 
		}
		system("pause");
	}
}





































